require 'active_record'
require 'active_record/connection_adapters/postgresql_adapter'

module ActiverecordPostgresqlAutoReconnect
  ActiveRecord::ConnectionAdapters::PostgreSQLAdapter.class_eval do
    def exec_no_cache_with_reconnect(*args)
      exec_no_cache_without_reconnect(*args)
    rescue ActiveRecord::StatementInvalid => e
      if e.to_s.include?('PG::ConnectionBad')
        ActiveRecord::Base.connection_pool.disconnect!
      end
      raise e
    end

    alias_method :exec_no_cache_without_reconnect, :exec_no_cache
    alias_method :exec_no_cache, :exec_no_cache_with_reconnect
  end
end
